#include "ros/ros.h"
#include "std_msgs/String.h"
#include "std_msgs/Int8.h"

#include "std_msgs/Float32.h"
#include "ihm.h"

//INCLUDES DE TCPSOCK.C, UDPSOCK.C I SOCKBACE.C
#include "SockBase.h" 
#include "UDPSock.h"
#include <stdio.h>  
#include "SockBase.h"

#include <sstream>
		//Declaracio de Variables globals
char * addrRobot;

char * addrIMU;
float aux1;
float aux2;
float aux3;

unsigned char bufModeCom[3];

//Definim configuraci� socket per PC





int sockIMU;
int start_send=0;

// Threads

void * recvIMU(void *num);


void startSocketIMU(void);
void gestio_int (int numero);
int calculaPaquet_PIC(void);
void calculaVarIMU(void);

int main(int argc, char **argv)
{


ros::init(argc, argv, "IMU");


ros::NodeHandle n;

	//DEFINIM ELS MISATGES QUE ES PUBLICARAN

	ros::Publisher Roll_pub = n.advertise<std_msgs::Float32>("Roll",1000);
	ros::Publisher Pitch_pub = n.advertise<std_msgs::Float32>("Pitch",1000);
	ros::Publisher Yaw_pub = n.advertise<std_msgs::Float32>("Yaw",1000);

ros::Rate loop_rate(1);

while (ros::ok())
  {    
     /**
     * This are a message object. You stuff it with data, and then publish it.
     *
     *Definim els objectes misatge
     *
     */
    std_msgs::Float32 Roll;
    std_msgs::Float32 Pitch;
    std_msgs::Float32 Yaw;


 /**
     * 			      			$$$$$   !!!!EL PROGRAMA ANIRA AQUI!!!   $$$$$$
     *
     */

int resultatRecv=1;
	struct itimerval val;			// Variable per la configuraci� del timer
	struct sigaction interrupcio;		// Variable per la configuraci� d'interrupcions
	
	//0x88 = Possem a 1 el bit de més pes per indicar que es un paquet amb el Yaw,
	//i l'altre 1 indica que es correció d'angle
	PIC_sendBuf_minim[0] = 0x88;

	if (1){
		
	
		
		addrIMU = "192.168.1.38";
		
		printf("\nX\n");
		printf("IP IMU: %s\n",addrIMU);
		
		//iniciem el buffer down
		int k=0;
		int h=0;
		for (k=0; k<=39; k++)
	{
			bufDown[k]=0;
		}
		for (h=0; h<=4; h++)
		{
			for (k=0; k<=39; k++)
			{
				bufUp[h][k]=0;
			}
		}
		
		
	


	
	}

	// CREACIO DEL THREAD
	
	if (pthread_create (&recvIMUTh, NULL, recvIMU, (void *) 1) != 0){
		printf("\nError al crear el thread de recvPC\n");
	}


	pthread_mutex_init (&mutex_nBufEnviar, NULL);

	val.it_interval.tv_sec=0;
	val.it_interval.tv_usec=15000;
	val.it_value.tv_sec=0;
	val.it_value.tv_usec=15000;
	setitimer(ITIMER_REAL, &val, NULL);
	

	//Interrupci� timer
	interrupcio.sa_handler = gestio_int;				// El manejador de de les senyals capturades es gestio_int
	sigemptyset (& (interrupcio . sa_mask));			// Especifiquem que no es bloquejar� cap senyal
	interrupcio.sa_flags = 0;					// Tots els flags desactivats
	sigaction(SIGALRM, &interrupcio, NULL);
	sigaction(SIGINT, &interrupcio, NULL);

	while(1){

	Roll.data=roll;
	Pitch.data = pitch;
	Yaw.data = yaw;

	//avisem al master que publicarem als topics

    ROS_INFO("%f", Roll.data);
    ROS_INFO("%f", Pitch.data);
    ROS_INFO("%f", Yaw.data);


	//Publiquem els misatges


    Roll_pub.publish(Roll); 
    Pitch_pub.publish(Pitch); 
    Yaw_pub.publish(Yaw); 
			
	
    ros::spinOnce();

    loop_rate.sleep();

  }

  return 0;


  }






}


void startSocketIMU(void){
	sockIMU = CreateTCPClient(addrIMU,10003);
}


// THREAD LECTURA DE IMU
void * recvIMU (void * num){

	int bytesRebuts=0, autoritzacio=1;// Autoritzem les peticions de comunicaci� entrants
	unsigned char bufReadEprom[2];
	signed short aux1,aux2;
	bufModeCom[0] = 0x10;
	bufModeCom[1] = 0x00;
	//Posem aquest byte a 0x31 per demanar que s'envii el vector de angles i acceleracions (instruccio 0x31)
	bufModeCom[2] = 0x31;

	bufReadEprom[0] = 0x08;

	while(1){
		startSocketIMU();
		while(bytesRebuts != -1){
			bytesRebuts = recv(sockIMU, IMU_getBuf, 1, MSG_OOB);
		}
		
		bufReadEprom[1] = 238;
		send(sockIMU, bufReadEprom, sizeof(bufReadEprom), 0);
		recv(sockIMU, IMU_getBuf, 2, MSG_WAITALL);
		aux1 = IMU_getBuf[0];
		aux1 = aux1 << 8;
		aux2 = IMU_getBuf[1];
		calculationCycle1 = aux1|aux2;
		printf("calculationCycle1: %d\n",calculationCycle1);


		bufReadEprom[1] = 240;
		send(sockIMU, bufReadEprom, sizeof(bufReadEprom), 0);
		recv(sockIMU, IMU_getBuf, 2, MSG_WAITALL);
		aux1 = IMU_getBuf[0];
		aux1 = aux1 << 8;
		aux2 = IMU_getBuf[1];
		calculationCycle2 = aux1|aux2;
		printf("calculationCycle2: %d\n",calculationCycle2);

		bufReadEprom[1] = 242;
		send(sockIMU, bufReadEprom, sizeof(bufReadEprom), 0);
		recv(sockIMU, IMU_getBuf, 2, MSG_WAITALL);
		aux1 = IMU_getBuf[0];
		aux1 = aux1 << 8;
		aux2 = IMU_getBuf[1];
		calculationCycle3 = aux1|aux2;
		printf("calculationCycle3: %d\n",calculationCycle3);

		bufReadEprom[1] = 246;
		send(sockIMU, bufReadEprom, sizeof(bufReadEprom), 0);
		recv(sockIMU, IMU_getBuf, 2, MSG_WAITALL);
		aux1 = IMU_getBuf[0];
		aux1 = aux1 << 8;
		aux2 = IMU_getBuf[1];
		calculationCycle4 = aux1|aux2;
		printf("calculationCycle4: %d\n",calculationCycle4);

		bufReadEprom[1] = 230;
		send(sockIMU, bufReadEprom, sizeof(bufReadEprom), 0);
		recv(sockIMU, IMU_getBuf, 2, MSG_WAITALL);
		aux1 = IMU_getBuf[0];
		aux1 = aux1 << 8;
		aux2 = IMU_getBuf[1];
		AccelGainScale = aux1|aux2;

		printf("AccelGainScale: %d\n",AccelGainScale);
		

		bufReadEprom[1] = 130;
		send(sockIMU, bufReadEprom, sizeof(bufReadEprom), 0);
		recv(sockIMU, IMU_getBuf, 2, MSG_WAITALL);
		aux1 = IMU_getBuf[0];
		aux1 = aux1 << 8;
		aux2 = IMU_getBuf[1];
		GyroGainScale = aux1|aux2;
		
		printf("GyroGainScale: %d\n",GyroGainScale);
		
		//Fiquem mode continu
		autoritzacio = send(sockIMU, bufModeCom, sizeof(bufModeCom), 0);		
		printf("enviat bufModeCom(Mode continu): %d\n",autoritzacio);

		printf("bufMode[0]: 0x%x\nbufMode[1]: 0x%x\nbufMode[2]: 0x%x\n",bufModeCom[0],bufModeCom[1],bufModeCom[2]);
		
		
		//Agafar be el paquet
		int i = 0;
		autoritzacio = recv(sockIMU, IMU_getBuf, 7, MSG_WAITALL);
		for(i=0; i<3; i++){
			printf("IMU_getBuf[%d] = 0x%x\n", i, IMU_getBuf[i]);
		}
		

		while(1){
			
			//Rebem les dades que ens interessa i les enviem cap al PC
			recv(sockIMU,IMU_getBuf,23, MSG_WAITALL);
			//recv(sockIMU, &bufUp[);
			h_yaw = IMU_getBuf[5];
			l_yaw = IMU_getBuf[6];
			calculaVarIMU();
		}

    

	}
	
}

//Desglosem els paquets que ha enviat l'IMU
void calculaVarIMU(void){
	//a IMU_getBuf tenim els 20 bytes que ens interessen
	unsigned short aux1;
	unsigned short aux2;

	h_yaw = IMU_getBuf[5];
	l_yaw = IMU_getBuf[6];


	aux1 = IMU_getBuf[1];  // Calcul de Roll
	aux1 = aux1 << 8;
	aux2 = IMU_getBuf[2];
	roll = aux1|aux2;
	//printf("\nroll: %f\n",roll);
	roll = roll*(360.0/65536.0);
	aux1=roll;

	aux1 = IMU_getBuf[3];  // Calcul de Pitch
	aux1 = aux1 << 8;
	aux2 = IMU_getBuf[4];
	pitch = aux1|aux2;
	pitch = pitch*(360.0/65536.0);
	aux2=pitch;
	

	aux1 = IMU_getBuf[5];  // Calcul de Yaw
	aux1 = aux1 << 8;
	aux2 = IMU_getBuf[6];
	yaw = aux1|aux2;
	yaw = yaw*(360.0/65536.0);
	aux3=yaw;

	printf("Roll: %f\tPitch: %f\tYaw: %f\n",roll, pitch, yaw);
	
	aux1 = IMU_getBuf[7];
	aux1 = aux1 < 8;
	aux2 = IMU_getBuf[8];
	accel_X = aux1|aux2;
	accel_X = accel_X*(32768000/AccelGainScale);

	aux1 = IMU_getBuf[9];
	aux1 = aux1 < 8;
	aux2 = IMU_getBuf[10];
	accel_Y = aux1|aux2;
	accel_Y = accel_Y*(32768000/AccelGainScale);

	aux1 = IMU_getBuf[11];
	aux1 = aux1 < 8;
	aux2 = IMU_getBuf[12];
	accel_Z = aux1|aux2;
	accel_Z = accel_Z*(32768000/AccelGainScale);

	printf("accel_X: %d\taccel_Y: %d\taccel_Z: %d\n",accel_X,accel_Y,accel_Z);

	aux1 = IMU_getBuf[13];
	aux1 = aux1 < 8;
	aux2 = IMU_getBuf[14];
	compAngRate_X = aux1|aux2;
	compAngRate_X = compAngRate_X;//(32768000/GyroGainScale);

	aux1 = IMU_getBuf[15];
	aux1 = aux1 < 8;
	aux2 = IMU_getBuf[16];
	compAngRate_Y = aux1|aux2;
	compAngRate_Y = compAngRate_Y;//(32768000/GyroGainScale);

	aux1 = IMU_getBuf[17];
	aux1 = aux1 < 8;
	aux2 = IMU_getBuf[18];
	compAngRate_Z = aux1|aux2;
	compAngRate_Z = compAngRate_Z;//(32768000/GyroGainScale);

	printf("compAngRate_X: %d\tcompAngRate_Y: %d\tcompAngRate_Z: %d\n",compAngRate_X,compAngRate_Y,compAngRate_Z);

	aux1 = IMU_getBuf[19];
	aux1 = aux1 << 8;
	aux2 = IMU_getBuf[20];
	timerTicks_IMU = aux1|aux2;
	timerTicks_IMU = timerTicks_IMU*0.0065536;
	//printf("timerTicks: %d\n",timerTicks_IMU);


}

// Gesti� de les senyals capturades
void gestio_int (int numero)
{
	int resultatRecv = 0;
	int i;
	char final1=0, final2=0, final3=0;

	switch (numero) 
	{
	case SIGALRM :
		
		break;

	case SIGINT:
		/**********************************************
		Codi executat per la interrupció de Ctrl+C. A part, està configurat per que quan Labview es desconecti
		salti aquesta interrupció.

		Aquesta part ens assegura que la transmissió de l'IMU es "tanca" correctament i que no queda res
		al buffer.
		***********************************************/
		printf("\nS'ha pulsat Ctrl+C!\n");
		

		printf("\nFinalitzant comunicacio amb IMU...");
		//Configurem el buffer per deixar de transmetre en continuu
		bufModeCom[0] = 0x10;
		bufModeCom[1] = 0x00;
		bufModeCom[2] = 0x00;
		
		//Enviem els 3 bytes
		resultatRecv = send(sockIMU, bufModeCom, 3, 0);

		//Com que podem rebre encara dades de l'IMU, anem rebent fins que llegim la seqüencia que ens indica
		//que s'ha deixat de transmetre en continuu: 0x10 , 0x00 i 0x00. Per aixo, fem servir les variables finalX
		//per cada valor a llegir.
		i = 0;
		while((final1==0)||(final2 == 0)||(final3 == 0)){
		recv(sockIMU, IMU_getBuf, 1, 0);
		//printf("\nLectura[%d]: 0x%x",i, IMU_getBuf[0]);i++;
		if(IMU_getBuf[0] == 0x10){
			final1 = 1;//printf("\nfinal1");
		}else if((IMU_getBuf[0] == 0x00)&&(final1 == 1)&&(final2 == 0)){
			final2 = 1;//printf("\nfinal2");
		}else if((IMU_getBuf[0] == 0x00)&&(final1 == 1)&&(final2 == 1)){
			final3 = 1;//printf("\nfinal3");
		}else{final1 = 0; final2 = 0; final3 = 0;}
		}
		//Rebem els 4 bytes que falten per llegir (al ficar en Polled mode es reben 7 (els 3 ja trobats i els 4 d'acontinuació)
		recv(sockIMU, IMU_getBuf, 4, 0);
		printf(" Ok !\n");
		CloseSock(sockIMU);
		

		printf("\nSortint ...\n\n");
		exit(1);
		break;
	}
}

		//FUNCIONS TCP


int CreateTCPServer(int Port)
{
	int s;

	s = CreateSock(SOCK_STREAM);

	if ( s == -1 )
		return -1;

	if (BindSock(s,Port) == -1 )
		return -1;

	if (listen(s, SOMAXCONN) < 0)
		return -1;

	return s;
}




int AcceptConn(int Sock,char * RemoteAddr)
{
	struct sockaddr_in addr;
	int addrSize = sizeof(struct sockaddr_in);
	int s;

	s = accept(Sock,(struct sockaddr *)&addr,(socklen_t *)&addrSize);

	strcpy(RemoteAddr,inet_ntoa(addr.sin_addr));

	return s;
}

int CreateTCPClient2(struct sockaddr_in dest_addr)
{
	int s;
	//struct sockaddr_in dest_addr;

	s = CreateSock(SOCK_STREAM);

	if ( s == -1 )
		return -1;

	dest_addr.sin_family = AF_INET;
	//dest_addr.sin_port = htons(Port);
	//HostNameToAddr(HostName,&dest_addr);

    if ( connect(s, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1 )
    	return -1;

    return s;
}

int CreateTCPClient(char * HostName,int Port)
{
	int s;
	struct sockaddr_in dest_addr;

	s = CreateSock(SOCK_STREAM);

	if ( s == -1 )
		return -1;

	dest_addr.sin_family = AF_INET;
	dest_addr.sin_port = htons(Port);
	HostNameToAddr(HostName,&dest_addr);

    if ( connect(s, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1 )
    	return -1;

    return s;
}

int TCPSend(int Sock,char * Data,int Len)
{
	return send(Sock, Data, Len, 0);
}

int TCPRecv(int Sock,char * Buf,int Len)
{

	return recv(Sock, Buf, Len, 0);
}

		//FUNCIONS SOCKBASE



int CreateSock(int SockType)
{
	return socket(AF_INET,SockType,0);

}

int BindSock(int Sock,int Port)
{
	struct sockaddr_in serv;

  	serv.sin_family=AF_INET;
  	serv.sin_addr.s_addr=htonl(INADDR_ANY);
  	serv.sin_port=htons(Port);

    return bind(Sock,(struct sockaddr *)&serv,sizeof(serv)) ;

}


int HostNameToAddr(char * HostName,struct sockaddr_in * Addr)
{
	struct hostent *hp;

  	hp=gethostbyname(HostName);
  	if(hp==(struct hostent *)0)
  		return -1;

  	memcpy((char *) &Addr->sin_addr,(char *)hp->h_addr,hp->h_length);


  	return 0;
}



void CloseSock(int Sock)
{
	if ( close(Sock) == -1 )
		perror("CloseSock");
}
